> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.0x.org/api-reference/cross-chain-ap-is/cross-chain/cross-chain-list-sources/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.0x.org/_mcp/server. # listSources GET https://api.0x.org/cross-chain/sources List available swap and bridge sources for a cross chain swap Reference: https://docs.0x.org/api-reference/cross-chain-ap-is/cross-chain/cross-chain-list-sources ## Request ### Headers - `0x-api-key` (string, required) — Visit dashboard.0x.org to get your API Key ## Response ### 200 Successful response - `bridges` (list of CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItems, required) — The array of bridge providers and their supported chain pairs - `swapSources` (list of CrossChainSourcesGetResponsesContentApplicationJsonSchemaSwapSourcesItems, required) — The array of liquidity sources and their supported chains - `zid` (string, required) — The unique ZeroEx identifier of the request ## Errors ### 400 Bad Request Error 400 error response - `CrossChain::listSourcesRequestBadRequestError` ### 500 Internal Server Error 500 error response - `CrossChain::listSourcesRequestInternalServerError` ## Types ### CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItems - `name` (string, required) — The name of the bridge provider - `chainPairs` (list of CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItemsChainPairsItems, required) — Origin-destination chain pairs supported by the bridge provider ### CrossChainSourcesGetResponsesContentApplicationJsonSchemaSwapSourcesItems - `name` (string, required) — The name of the liquidity sources aggregated by 0x - `chainIds` (list of double, required) — The numeric chain IDs of the chains supported by the liquidity source ### INPUT_INVALID - `name` (enum, required) - Allowed values: `INPUT_INVALID` - `message` (string, required) - `data` (InputInvalidData, required) ### INTERNAL_SERVER_ERROR - `name` (enum, required) - Allowed values: `INTERNAL_SERVER_ERROR` - `message` (string, required) - `data` (InternalServerErrorData, required) ### UNCATEGORIZED - `name` (enum, required) - Allowed values: `UNCATEGORIZED` - `message` (string, required) - `data` (UncategorizedData, required) ### CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItemsChainPairsItems - `originChainId` (double, required) — The numeric chain ID of the origin chain - `destinationChainId` (double, required) — The numeric chain ID of the destination chain ### InputInvalidData - `zid` (string, required) — The unique ZeroEx identifier of the request - `details` (list of InputInvalidDataDetailsItems, required) — The list of invalid inputs ### InternalServerErrorData - `zid` (string, required) — The unique ZeroEx identifier of the request ### UncategorizedData - `zid` (string, required) — The unique ZeroEx identifier of the request ### InputInvalidDataDetailsItems - `field` (string, required) — The input field name - `reason` (string, required) — The validation failure reason ## Examples **Response** ```json { "bridges": [ { "name": "string", "chainPairs": [ { "originChainId": 1.1, "destinationChainId": 1.1 } ] } ], "swapSources": [ { "name": "string", "chainIds": [ 1.1 ] } ], "zid": "string" } ``` **SDK Code** ```python import requests url = "https://api.0x.org/cross-chain/sources" headers = {"0x-api-key": "0x-api-key"} response = requests.get(url, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.0x.org/cross-chain/sources'; const options = {method: 'GET', headers: {'0x-api-key': '0x-api-key'}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "net/http" "io" ) func main() { url := "https://api.0x.org/cross-chain/sources" req, _ := http.NewRequest("GET", url, nil) req.Header.Add("0x-api-key", "0x-api-key") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.0x.org/cross-chain/sources") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Get.new(url) request["0x-api-key"] = '0x-api-key' response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.get("https://api.0x.org/cross-chain/sources") .header("0x-api-key", "0x-api-key") .asString(); ``` ```php request('GET', 'https://api.0x.org/cross-chain/sources', [ 'headers' => [ '0x-api-key' => '0x-api-key', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.0x.org/cross-chain/sources"); var request = new RestRequest(Method.GET); request.AddHeader("0x-api-key", "0x-api-key"); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["0x-api-key": "0x-api-key"] let request = NSMutableURLRequest(url: NSURL(string: "https://api.0x.org/cross-chain/sources")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "GET" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` > Developer documentation for the 0x API. Embed swaps in your onchain app. Access 10+ million tokens with liquidity from 150+ exchanges with a single API.